//  VirtualDub - Video processing and capture application
//  Copyright (C) 1998-2005 Avery Lee
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

//  This version has been modified by fccHandler, May 2006

#include <windows.h>
#include <vd2/system/error.h>

#include "DataVector.h"

//////////////////////////////////////////////////////////////////////////
//
//							DataVector
//
//////////////////////////////////////////////////////////////////////////

/*
DataVector::DataVector(int _item_size) : item_size(_item_size) {
	first = last = NULL;
	count = 0;
}
*/
DataVector::DataVector(int item_size) {
	_item_size = item_size;
	first = last = NULL;
	count = 0;
}

DataVector::~DataVector() {
	DataVectorBlock *i, *j;

	j = first;
	while(i = j) {
		j = i->next;
		delete i;
	}
}

void DataVector::_Add(void *pp) {
	if (!last || last->index > (DataVectorBlock::BLOCK_SIZE - _item_size)) {
		DataVectorBlock *ib = new DataVectorBlock();

		if (!ib) throw MyMemoryError();

		if (last)	last->next = ib;
		else		first = ib;

		last = ib;
	}

	memcpy(last->heap + last->index, pp, _item_size);
	last->index += _item_size;
	++count;
}

void DataVector::Add(void *pp) {
	if (!last || last->index >= (DataVectorBlock::BLOCK_SIZE - _item_size)) {
		_Add(pp);
	} else {
		memcpy(last->heap + last->index, pp, _item_size);
		last->index += _item_size;
		++count;
	}
}

int DataVector::Length() {
	return count;
}

void *DataVector::MakeArray() {

	char *array = new char[count * _item_size];
	char *ptr = array;

	DataVectorBlock *dvb = first;

	if (!array) throw MyMemoryError();

	while(dvb) {
		memcpy(ptr, dvb->heap, dvb->index);
		ptr += dvb->index;

		dvb=dvb->next;
	}

	return array;
}
